#!/usr/bin/perl -w 

##########################################
## Horizon +tv.de +tvtoday +Magentatv   ##
## Mapper                               ##
## Revision 8                           ##
## DeBaschdi                            ##
## takealug.de                          ##
##########################################

## Hier werden Die EIT NORM Genre Aufgeführt und definiert##
#  0x00    undefined
my $x00 = "Keine Informationen Enthalten";
#  0x10    Movie / Drama
my $x10 = "Movie / Drama";
#  0x11    Detective / Thriller
my $x11 = "Detective / Thriller";
#  0x12    Adventure / Western / War
my $x12 = "Adventure / Western / War";
#  0x13    Science fiction / Fantasy / Horror
my $x13 = "Science fiction / Fantasy / Horror";
#  0x14    Comedy
my $x14 = "Comedy";
#  0x15    Soap / Melodrama / Folkloric
my $x15 = "Soap / Melodrama / Folkloric";
#  0x16    Romance
my $x16 = "Romance";
#  0x17    Serious / Classical / Religious / Historical movie / Drama
my $x17 = "Serious / Classical / Religious / Historical movie / Drama";
#  0x18    Adult movie / Drama
my $x18 = "Adult movie / Drama";
#  0x20    News / Current affairs
my $x20 = "News / Current affairs";
#  0x21    News / Weather report
my $x21 = "News / Weather report";
#  0x22    News magazine
my $x22 = "News magazine";
#  0x23    Documentary
my $x23 = "Documentary";
#  0x24    Discussion / Interview / Debate
my $x24 = "Discussion / Interview / Debate";
#  0x30    Show / Game show
my $x30 = "Show / Game show";
#  0x31    Game show / Quiz / Contest
my $x31 = "Game show / Quiz / Contest";
#  0x32    Variety show
my $x32 = "Variety show";
#  0x33    Talk show
my $x33 = "Talk show";
#  0x40    Sports
my $x40 = "Sports";
#  0x41    Special events (Olympic Games, World Cup, etc.)
my $x41 = "Special events (Olympic Games, World Cup, etc.)";
#  0x42    Sports magazines
my $x42 = "Sports magazines";
#  0x43    Football / Soccer
my $x43 = "Football / Soccer";
#  0x44    Tennis / Squash
my $x44 = "Tennis / Squash";
#  0x45    Team sports (excluding football)
my $x45 = "Team sports (excluding football)";
#  0x46    Athletics
my $x46 = "Athletics";
#  0x47    Motor sport
my $x47 = "Motor sport";
#  0x48    Water sport
my $x48 = "Water sports";
#  0x49    Winter sports
my $x49 = "Winter sports";
#  0x4A    Equestrian
my $x4a = "Equestrian" ;
#  0x4B    Martial sports
my $x4b = "Martial Sports" ;
#  0x50    Children's / Youth programs
my $x50 = "Children's / Youth programs";
#  0x51    Pre-school children's programs
my $x51 = "Pre-school children's programs";
#  0x52    Entertainment programs for 6 to14
my $x52 = "Entertainment programs for 6 to 14";
#  0x53    Entertainment programs for 10 to 16
my $x53 = "Entertainment programs for 10 to 16";
#  0x54    Informational / Educational / School programs
my $x54 = "Informational / Educational / School programs";
#  0x55    Cartoons / Puppets
my $x55 = "Cartoons / Puppets";
#  0x60    Music / Ballet / Dance
my $x60 = "Music / Ballet / Dance";
#  0x61    Rock / Pop
my $x61 = "Rock / Pop";
#  0x62    Serious music / Classical music
my $x62 = "Serious music / Classical music";
#  0x63    Folk / Traditional music
my $x63 = "Folk / Traditional music";
#  0x64    Jazz
my $x64 = "Jazz";
#  0x65    Musical / Opera
my $x65 = "Musical / Opera";
#  0x66    Ballet
my $x66 = "Ballet";
#  0x70    Arts / Culture (without music)
my $x70 = "Arts / Culture (without music)";
#  0x71    Performing arts
my $x71 = "Performing arts";
#  0x72    Fine arts
my $x72 = "Fine arts";
#  0x73    Religion
my $x73 = "Religion";
#  0x74    Popular culture / Traditional arts
my $x74 = "Popular culture / Traditional arts";
#  0x75    Literature
my $x75 = "Literature";
#  0x76    Film / Cinema
my $x76 = "Film / Cinema";
#  0x77    Experimental film / Video
my $x77 = "Experimental film / Video";
#  0x78    Broadcasting / Press
my $x78 = "Broadcasting / Press";
#  0x79    New media
my $x79 = "New media";
#  0x7A    Arts / Culture magazines
my $x7a = "Arts / Culture magazines";
#  0x7B    Fashion
my $x7b = "Fashion";
#  0x80    Social / Political issues / Economics
my $x80 = "Social / Political issues / Economics";
#  0x81    Magazines / Reports / Documentary
my $x81 = "Magazines / Reports / Documentary";
#  0x82    Economics / Social advisory
my $x82 = "Economics / Social advisory";
#  0x83    Remarkable people
my $x83 = "Remarkable people";
#  0x90    Education / Science / Factual topics
my $x90 = "Education / Science / Factual topics";
#  0x91    Nature / Animals / Environment
my $x91 = "Nature / Animals / Environment";
#  0x92    Technology / Natural sciences
my $x92 = "Technology / Natural sciences";
#  0x93    Medicine / Physiology / Psychology
my $x93 = "Medicine / Physiology / Psychology";
#  0x94    Foreign countries / Expeditions
my $x94 = "Foreign countries / Expeditions";
#  0x95    Social / Spiritual sciences
my $x95 = "Social / Spiritual sciences";
#  0x96    Further education
my $x96 = "Further education";
#  0x97    Languages
my $x97 = "Languages";
#  0xA0    Leisure hobbies
my $xa0 = "Leisure hobbies";
#  0xA1    Tourism / Travel
my $xa1 = "Tourism / Travel";
#  0xA2    Handicraft
my $xa2 = "Handicraft";
#  0xA3    Motoring
my $xa3 = "Motoring";
#  0xA4    Fitness and health
my $xa4 = "Fitness and health";
#  0xA5    Cooking
my $xa5 = "Cooking";
#  0xA6    Advertisement / Shopping
my $xa6 = "Advertisement / Shopping";
#  0xA7    Gardening
my $xa7 = "Gardening";
#  0xB0    Original language
my $xb0 = "Original language";
#  0xB1    Black and white
my $xb1 = "Black and white";
#  0xB2    Unpublished
my $xb2 = "Unpublished";
#  0xB3    Live broadcast
my $xb3 = "Live broadcast";

my %REPLACE=(

##Exclude warnings for correct EIT Genre
"Keine Informationen Enthalten"									=> $x00,
"Movie / Drama"													=> $x10,
"Detective / Thriller"											=> $x11,
"Adventure / Western / War"										=> $x12,
"Science fiction / Fantasy / Horror"							=> $x13,
"Comedy"														=> $x14,
"Soap / Melodrama / Folkloric"									=> $x15,
"Romance"														=> $x16,
"Serious / Classical / Religious / Historical movie / Drama"	=> $x17,
"Adult movie / Drama"											=> $x18,
"News / Current affairs"										=> $x20,
"News / Weather report"											=> $x21,
"News magazine"													=> $x22,
"Documentary"													=> $x23,
"Discussion / Interview / Debate"								=> $x24,
"Show / Game show"												=> $x30, 
"Game show / Quiz / Contest"									=> $x31,
"Variety show"													=> $x32,
"Talk show"														=> $x33,
"Sports"														=> $x40,
"Special events (Olympic Games, World Cup, etc.)"				=> $x41,
"Sports magazines"												=> $x42,
"Football / Soccer"												=> $x43,
"Tennis / Squash"												=> $x44,
"Team sports (excluding football)"								=> $x45,
"Athletics"														=> $x46,
"Motor sport"													=> $x47,
"Water sports"													=> $x48,
"Winter sports"													=> $x49,
"Equestrian" 													=> $x4a,
"Martial Sports"												=> $x4b,
"Children's / Youth programs"									=> $x50,
"Pre-school children's programs"								=> $x51,
"Entertainment programs for 6 to 14"							=> $x52,
"Entertainment programs for 10 to 16"							=> $x53,
"Informational / Educational / School programs"					=> $x54,
"Cartoons / Puppets"											=> $x55,
"Music / Ballet / Dance"										=> $x60,
"Rock / Pop"													=> $x61,
"Serious music / Classical music"								=> $x62,
"Folk / Traditional music"										=> $x63,
"Jazz"															=> $x64,
"Musical / Opera"												=> $x65,
"Ballet"														=> $x66,
"Arts / Culture (without music)"								=> $x70, 
"Performing arts"												=> $x71,
"Fine arts"														=> $x72,
"Religion"														=> $x73,
"Popular culture / Traditional arts"							=> $x74,
"Literature"													=> $x75,
"Film / Cinema"													=> $x76,
"Experimental film / Video"										=> $x77,
"Broadcasting / Press"											=> $x78,
"New media"														=> $x79,
"Arts / Culture magazines"										=> $x7a,
"Fashion"														=> $x7b,
"Social / Political issues / Economics"							=> $x80,
"Magazines / Reports / Documentary"								=> $x81,
"Economics / Social advisory"									=> $x82,
"Remarkable people"												=> $x83,
"Education / Science / Factual topics"							=> $x90,
"Nature / Animals / Environment"								=> $x91,
"Technology / Natural sciences"									=> $x92,
"Medicine / Physiology / Psychology"							=> $x93,
"Foreign countries / Expeditions"								=> $x94,
"Social / Spiritual sciences"									=> $x95,
"Further education"												=> $x96,
"Languages"														=> $x97,
"Leisure hobbies"												=> $xa0,
"Tourism / Travel"												=> $xa1,
"Handicraft"													=> $xa2,
"Motoring"														=> $xa3,
"Fitness and health"											=> $xa4,
"Cooking"														=> $xa5,
"Advertisement / Shopping"										=> $xa6,
"Gardening"														=> $xa7,
"Original language"												=> $xb0,
"Black and white"												=> $xb1,
"Unpublished"													=> $xb2,
"Live broadcast"												=> $xb3,

#######################################################################################
#                                                                                     #
#  Ab hier werden die Grabber-Genres / -Categories zum EIT-kompatiblen Genre gemappt  #
#                                                                                     #
#######################################################################################

# 0x00 undefined
 "Programm nach Ansage" 										=> $x00 ,
 "Programminformation"											=> $x00 ,
 "Serie/Sonstige"												=> $x00 ,
 "Sonstiges"													=> $x00 ,
 "Sendepause"													=> $x00 ,
 "undefined"													=> $x00 ,
 "Undefiniert"													=> $x00 ,
 "undefiniert"													=> $x00 ,
 "Verschiedenes"												=> $x00 ,

# 0x10 Movie / Drama
 "Drama"														=> $x10 ,
 "Drama (Film)"													=> $x10 ,
 "Drama (Filme)"												=> $x10 ,
 "Drama (film)"													=> $x10 ,            
 "Drama (filme)"												=> $x10 ,
 "Familienfilm"													=> $x10 ,
 "FILM"															=> $x10 ,
 "Film"															=> $x10 ,
 "Film/Kino"													=> $x10 ,
 "Filmessay"													=> $x10 ,
 "Melodram"														=> $x10 ,
 "Melodrama"													=> $x10 ,
 "Movie"														=> $x10 ,
 "movie"														=> $x10 ,           
 "Spielfilm"													=> $x10 ,
 "Spielfilme"													=> $x10 ,
 "Spielfilm/Drama"												=> $x10 ,
 "Spielfilm/Sonstige"											=> $x10 , 
 "Sportfilm"													=> $x10 ,

# 0x11 Detective / Thriller
 "Agentenfilmparodie"											=> $x11 ,
 "Krimi"														=> $x11 ,
 "Krimiserie"													=> $x11 ,
 "Serie/Krimi"													=> $x11 ,
 "Spielfilm/Krimi"												=> $x11 ,
 "Spielfilm/Thriller"											=> $x11 ,
 "Thriller"														=> $x11 ,

# 0x12 Adventure / Western / War
 "Abenteuer"													=> $x12 ,
 "Abenteuerfilm"												=> $x12 ,
 "Action"  														=> $x12 ,
 "Actionfilm"													=> $x12 ,
 "Kriegsfilm"													=> $x12 ,
 "Kriegsfilme"													=> $x12 ,
 "Movie/Action"													=> $x12 ,
 "Movie/Adventure"												=> $x12 ,
 "Serie/Action"													=> $x12 ,
 "Spielfilm/Abenteuer"											=> $x12 ,
 "Spielfilm/Action"												=> $x12 ,
 "Spielfilm/Kriegsfilme"										=> $x12 ,
 "Spielfilm/Western"											=> $x12 ,
 "Western"														=> $x12 ,

# 0x13 Science fiction / Fantasy / Horror
 "Fantasy"														=> $x13 ,
 "Fantasyabenteuer"												=> $x13 ,
 "Fantasyfilm"													=> $x13 ,
 "Horror"														=> $x13 ,
 "Movie/Fantasy"												=> $x13 ,
 "Movie/Horror"													=> $x13 ,
 "Sci Fi"														=> $x13 ,
 "Sci-Fi"														=> $x13 ,
 "Sci-Fi/Horror"												=> $x13 ,
 "Science-Fiction-Action"										=> $x13 ,
 "ScienceFiction"												=> $x13 ,
 "Spielfilm/Science fiction"									=> $x13 ,
 "Serie/Science fiction"										=> $x13 ,
 "Spielfilm/Fantasy"											=> $x13 ,
 "Spielfilm/Horror"												=> $x13 ,

# 0x14 Comedy
 "Actionkomödie"												=> $x14 ,
 "Comedy"														=> $x14 ,
 "Familienkomödie"												=> $x14 ,
 "Fantasykomödie"												=> $x14 ,
 "Humour"														=> $x14 ,
 "Komödie"														=> $x14 ,
 "Satire"														=> $x14 ,
 "Serie/Comedy"													=> $x14 , 
 "Spielfilm/Comedy"												=> $x14 , 
 "Teenagerkomödie"												=> $x14 ,
 "Theaterkomödie"												=> $x14 ,
 "Tragikomödie"													=> $x14 ,
 "Unterhaltung/Comedy"											=> $x14 ,
 "Weihnachtskomödie"											=> $x14 ,


# 0x15 Soap / Melodrama / Folkloric
 "Drama (Serie)"												=> $x15 ,
 "Serie/Drama"													=> $x15 ,
 "Series/Action"												=> $x15 ,
 "Series/Drama"													=> $x15 ,
 "Series Drama"													=> $x15 ,
 "Serie/Soap"													=> $x15 ,
 "Series/Soap"													=> $x15 ,
 "Sitcom"														=> $x15 ,
 "Soap"															=> $x15 ,
 "Theater"														=> $x15 ,
 "TV Drama"														=> $x15 ,
 

# 0x16 Romance
 "Liebesfilm"													=> $x16 ,
 "Romance"														=> $x16 ,
 "Romance/Drama"												=> $x16 ,
 "Romantik"														=> $x16 ,
 "Romanze"														=> $x16 ,
 "Serie/Romantik"												=> $x16 ,
 "Spielfilm/Romantik"											=> $x16 ,

# 0x17 Serious / Classical / Religious / Historical movie / Drama
 "Heimatfilm"													=> $x17 ,
 "Historienfilm"												=> $x17 ,

# 0x18 Adult movie / Drama
 "Erotik"														=> $x18 ,
 "Adult"														=> $x18 ,
 "Erotik/Spielfilm-Erotik"										=> $x18 ,
 "Erotik/Serie-Erotik"											=> $x18 ,
 "Erotischer Film"												=> $x18 ,
 "erotiek"														=> $x18 ,
 "Erotiek"														=> $x18 ,
 "Erotyka"														=> $x18 ,
 "program erotyczny"											=> $x18 ,
 "Proprietary"													=> $x18 ,
 "VOLWASSENEN"													=> $x18 ,
 "film erotyczny"												=> $x18 ,

# 0x20 News
 "Nachrichten"													=> $x20 ,
 "Nachrichten/Info/Finanzen"									=> $x20 ,
 "Nachrichten/Info/Politik"										=> $x20 ,
 "Nachrichten/Info/Sonstige"									=> $x20 ,
 "News"															=> $x20 ,
 "News/Documentary"												=> $x20 ,
 "News/Other"													=> $x20 ,
 "News/Politics"												=> $x20 ,
 "Wiadomości"													=> $x20 ,

# 0x21 News / Weather report
 "Nachrichten/Info/Wetter"										=> $x21 ,
 "Wetter"														=> $x21 ,

# 0x22 News magazine
 "Info"															=> $x22 ,
 "Nachrichten/Info/Magazin"										=> $x22 ,

# 0x23 Documentary
 "Dokumentation"												=> $x23 ,
 "Documentary"													=> $x23 ,
 "Dokument"														=> $x23 ,
 "Literaturverfilmung"											=> $x23 ,
 "Dokufilm"														=> $x23 ,
 "Modedoku"														=> $x23 ,
 "Dokumentarfilm"												=> $x23 ,
 "Dokureihe"													=> $x23 ,
 "Doku-Reihe"													=> $x23 ,
 "Dokuserie"													=> $x23 ,
 "Doku"															=> $x23 ,
 "Studio-Doku"													=> $x23 ,
 "Dokuporträt"													=> $x23 ,
 "Nachrichten/Info/Dokumentation"								=> $x23 ,
 "Musikdokureihe"												=> $x23 ,
 "Drehbericht"													=> $x23 ,
 "Dokusoap"														=> $x23 ,

# 0x24 Discussion / Interview / Debate
 "Talk"															=> $x24 ,
 "Gespräch"														=> $x24 ,

# 0x30 Show / Game show
 "Clipshow"														=> $x30 ,
 "Entertainment/Reality"										=> $x30 ,
 "Entertainment/Show"											=> $x30 ,
 "Program Rozrywkowy"											=> $x30 ,
 "Reality"														=> $x30 ,
 "Show"															=> $x30 ,
 "Unterhaltung"													=> $x30 ,
 "Unterhaltung/Reality"											=> $x30 ,
 "Unterhaltung/Shows"											=> $x30 ,
 "Unterhaltungsshow"											=> $x30 ,
 
# 0x31 Game show / Quiz / Contest
 "Castingshow"													=> $x31 ,
 "Game Show"													=> $x31 ,
 "Spielshow"													=> $x31 ,
 "Unterhaltung/Game"											=> $x31 ,

# 0x32 Variety show
 "Variety Show"													=> $x32 ,
 
# 0x33 Talk show
 "Talk Show"													=> $x33 ,
 "Talk-Show"													=> $x33 ,
 "Talkshow"														=> $x33 ,
 "Unterhaltung/Talkshow"										=> $x33 ,         

# 0x40 Sports
 "Billard"														=> $x40 ,
 "Bogenschießen"												=> $x40 ,
 "deGenGolf"													=> $x40 ,
 "Extremsport"													=> $x40 ,
 "Fechten"														=> $x40 ,
 "Radsport"														=> $x40 ,
 "Snooker"														=> $x40 , 
 "Sport"														=> $x40 ,
 "Sport/Golf"													=> $x40 ,
 "Sport/Radsport"												=> $x40 ,
 "Sport/Sonstige"												=> $x40 ,
 "sports"														=> $x40 ,
 
# 0x41 Special events (Olympic Games, World Cup, etc.)
 "Special Event"												=> $x41 ,    
 "Sport/Besondere Ereignisse"									=> $x41 ,

# 0x42 Sports magazines
 "Sport Magazin"												=> $x42 ,
 "Sport-Magazin"												=> $x42 ,
 "Sport/Reportage"												=> $x42 ,
 "Sportnews"													=> $x42 ,

# 0x43 Football / Soccer
 "deGenSoccer"													=> $x43 ,
 "enGenSoccer"													=> $x43 ,
 "frGenSoccer"													=> $x43 ,
 "Fussball"														=> $x43 ,
 "Fußball"														=> $x43 ,
 "Soccer"														=> $x43 ,
 "Sport/Fußball"												=> $x43 ,
 
# 0x44 Tennis / Squash
 "deGenTennis"													=> $x44 ,
 "enGenTennis"													=> $x44 ,
 "frGenTennis"													=> $x44 ,
 "Sport/Squash"													=> $x44 ,
 "Sport/Tennis"													=> $x44 ,
 "Squash"														=> $x44 ,
 "Tennis"														=> $x44 ,
 "Tischtennis"													=> $x44 ,

# 0x45 Team sports (excluding football)
 "Basketball"													=> $x45 ,
 "deGenHandball"												=> $x45 ,
 "deGenIceHockey"												=> $x45 ,
 "enGenIceHockey"												=> $x45 ,
 "frGenIceHockey"												=> $x45 ,
 "Handball"														=> $x45 ,
 "Sport/Mannschaftssport"										=> $x45 ,
 "Team Sport"													=> $x45 ,
 "Teamsport"													=> $x45 ,

# 0x46 Athletics
 "Leichtathletik"												=> $x46 ,
 "Gewichtheben"													=> $x46 ,
 "Sport/Leichtathletik"											=> $x46 ,

# 0x47 Motor sport
 "Autosport"													=> $x47 ,
 "Formel 1"														=> $x47 ,
 "Motorradsport"												=> $x47 ,
 "Motorsport"													=> $x47 ,
 "Sport/Motorsport"												=> $x47 ,
 "Sports/Motor sports"											=> $x47 ,

# 0x48 Water sport
 "Schwimmen"													=> $x48 ,
 "Sport/Wassersport"											=> $x48 ,
 "Wassersport"													=> $x48 , 

# 0x49 Winter sports
 "Curling"														=> $x49 ,
 "deGenSKi"														=> $x49 ,
 "Eisschnellauf"												=> $x49 ,
 "Langlauf"														=> $x49 ,
 "Nordische Kombination"										=> $x49 ,
 "Ski alpin"													=> $x49 ,
 "Skiakrobatik"													=> $x49 ,
 "Skispringen"													=> $x49 ,
 "Sport/Wintersport"											=> $x49 ,
 "Wintersport"													=> $x49 ,

# 0x4A Equestrian
 "Reitsport"													=> $x4a ,  
 "Sport/Reiten"													=> $x4a ,

# 0x4B Martial sports
 "Kampfsport"													=> $x4b ,
 "enGenWrestling"												=> $x4b ,
 "deGenWrestling"												=> $x4b ,
 "frGenWrestling"												=> $x4b ,
 "Judo"															=> $x4b ,
 "Sport/Kampfsport"												=> $x4b ,

# 0x50 Children's / Youth programs
 "Children/Series"												=> $x50 ,
 "Kinder"														=> $x50 ,
 "Kids"															=> $x50 ,
 "Jugend"														=> $x50 ,
 "Kinderfilm"													=> $x50 ,
 "Jugendfilm"													=> $x50 ,
 "Märchenfilm"													=> $x50 ,
 "Kinder/Jugend/Serien"											=> $x50 ,
 "Kinderabenteuer"												=> $x50 ,
 "Kinder/Jugend/Show"											=> $x50 ,
 "Kinderkomödie"												=> $x50 ,
 "Kinderkrimi"													=> $x50 ,

# 0x51 Pre-school children's programs
 "Kinder, 0 6"													=> $x51 ,
 "Kids, 0 6"													=> $x51 ,

# 0x52 Entertainment programs for 6 to14
 "Kids, 6 14"													=> $x52 ,
 "Kids, 6-14"													=> $x52 ,
 "Kinder, 6 14"													=> $x52 ,
 "Kinder, 6-14"													=> $x52 ,

# 0x53 Entertainment programs for 10 to 16
 "Kids, 10 16"													=> $x53 ,
 "Kinder, 10 16"												=> $x53 ,

# 0x54 Informational / Educational / School programs
 "Knowledge"													=> $x54 ,


# 0x55 Cartoons / Puppets
 "Animation"													=> $x55 ,
 "Animationsfilm"												=> $x55 ,
 "Spielfilm/Zeichentrick"										=> $x55 ,
 "Trickfilm"													=> $x55 ,
 "Zeichentrick"													=> $x55 ,
 "Zeichentrickfilm"												=> $x55 ,
 "Zeichentrickserie"											=> $x55 ,

# 0x60 Music / Ballet / Dance
 "Ballet"														=> $x60 ,
 "Ballett"														=> $x60 ,
 "Clipcharts"													=> $x60 ,
 "Easy Listening"												=> $x60 ,
 "Music"														=> $x60 ,
 "Music Clips"													=> $x60 ,
 "Music Show"													=> $x60 ,
 "Musik"														=> $x60 ,
 "Musik-Clips"													=> $x60 ,
 "Musikclips"													=> $x60 ,
 "Musik/Sonstige"												=> $x60 ,
 "Musik/Tanz"													=> $x60 ,
 "Musikdoku"													=> $x60 ,
 "Musikfilm"													=> $x60 ,
 "Musikshow"													=> $x60 ,
 "Muziek"														=> $x60 ,
 "Muzyka"														=> $x60 ,
 "Talk und Musik"												=> $x60 ,
 "Tanz"															=> $x60 ,
 "Tanzdoku"														=> $x60 ,
 "Zeitgenössische Musik"										=> $x60 ,

# 0x61 Rock / Pop
 "Pop"															=> $x61 ,
 "Pop &amp; Rock"												=> $x61 ,
 "Rock"															=> $x61 ,
 "Rock/Pop"														=> $x61 , 
 "Rock und Pop"													=> $x61 ,

# 0x62 Serious music / Classical music
 "Classical Music"												=> $x62 ,
 "Klassik"														=> $x62 ,

# 0x63 Folk / Traditional music
 "Volksmusik"													=> $x63 ,

# 0x64 Jazz
 "Jazz"															=> $x64 ,

# 0x65 Musical / Opera
 "Musical"														=> $x65 ,
 "Musical/Oper"													=> $x65 ,
 "Musik/Musical"												=> $x65 ,
 "Musik/Oper"													=> $x65 ,
 "Spielfilm/Musical"											=> $x65 ,
 "Konzert"														=> $x65 ,
 "Oper"															=> $x65 ,

# 0x66 Ballet


# 0x70 Arts / Culture (without music)
 "Culture"														=> $x70 ,
 "Entertainment/Other"											=> $x70 ,
 "Kultur"														=> $x70 ,
 "Kunst"														=> $x70 ,
 "Kunst Magazin"												=> $x70 ,
 "Kunstdoku"													=> $x70 ,
 "Kunstmagazin"													=> $x70 ,
 "Kunstreportage"												=> $x70 ,
 "Lifestyle"													=> $x70 ,
 "Unterhaltung/Lifestyle"										=> $x70 ,
 "Unterhaltung/Sonstige"										=> $x70 ,

# 0x71 Performing arts
 "Darstellende Kunst"											=> $x71 ,
 "Darst. Kunst"													=> $x71 ,
 "Porträt"														=> $x71 ,
 "Portrait"														=> $x71 ,
 "Biografie"													=> $x71 ,

# 0x72 Fine arts
 "Bildende Kunst"												=> $x72 ,

# 0x73 Religion
 "Kirche und Religion"											=> $x73 ,
 "Religion"														=> $x73 ,
 "Themen/Religion"												=> $x73 ,

# 0x74 Popular culture / Traditional arts
 "Populäre Kunst"												=> $x74 ,

# 0x75 Literature
 "Literatur"													=> $x75 ,
 "Literaturmagazin"												=> $x75 ,

# 0x76 Film / Cinema
 "Film"															=> $x76 ,             
 "Kino"															=> $x76 ,

# 0x77 Experimental film / Video


# 0x78 Broadcasting / Press


# 0x79 New media


# 0x7A Arts / Culture magazines


# 0x7B Fashion


# 0x80 Social / Political issues / Economics
 "Gesellschaft"													=> $x80 ,
 "Politik"														=> $x80 ,
 "Queer"														=> $x80 ,
 "Soziales/Politik"												=> $x80 ,
 "Themen/Politik"												=> $x80 ,

# 0x81 Magazines / Reports / Documentary
 "Designreportage"												=> $x81 ,
 "Infomagazin"													=> $x81 ,
 "Magazin"														=> $x81 ,
 "Magazine"														=> $x81 ,
 "Regionalmagazin"												=> $x81 ,
 "Report"														=> $x81 ,
 "Reportage"													=> $x81 ,
 "Reportagereihe"												=> $x81 ,
 "Wissen"														=> $x81 ,

# 0x82 Economics / Social advisory
 "Economy"														=> $x82 ,
 "Themen/Wirtschaft"											=> $x82 ,
 "Themen/Wissenschaft"											=> $x82 ,
 "Wirtschaft"													=> $x82 ,
 "Wissenschaft"													=> $x82 ,

# 0x83 Remarkable people
 "Berühmte Leute"												=> $x83 ,

# 0x90 Education / Science / Factual topics
 "Bildung"														=> $x90 ,
 "Education / Science / Factual topic"							=> $x90 ,
 "Factual"														=> $x90 ,
 "Fortbildung"													=> $x90 ,
 "Geschichte"													=> $x90 ,
 "Themen/Bildung"												=> $x90 ,
 "Themen/Geschichte"											=> $x90 ,
 "Weiterbildung"												=> $x90 ,

# 0x91 Nature / Animals / Environment
 "Kamerafahrt"													=> $x91 ,
 "Natur"														=> $x91 ,
 "Natur und Tiere"												=> $x91 ,
 "Special Interest/Nature"										=> $x91 ,
 "Themen/Natur"													=> $x91 ,

# 0x92 Technology / Natural sciences
 "Technologie"													=> $x92 ,

# 0x93 Medicine / Physiology / Psychology
 "Medizin"														=> $x93 ,

# 0x94 Foreign countries / Expeditions
 "Expeditionen"													=> $x94 ,

# 0x95 Social / Spiritual sciences
 "Soziales"														=> $x95 ,

# 0x96 Further education
 "Ratgeber"														=> $x96 ,

# 0x97 Languages
 "Sprachen"														=> $x97 , 
 "USA"															=> $x97 ,

# 0xA0 Leisure hobbies
 "Freizeit"														=> $xa0 ,
 "Leisure"														=> $xa0 ,
 "Freizeit und Hobby"											=> $xa0 ,
 "Garten"														=> $xa0 ,
 "Unterhaltung/Haus&Garten"										=> $xa0 ,
 "Special Interest/Sonstige"									=> $xa0 ,
 "Special Interest/Sience"										=> $xa0 ,

# 0xA1 Tourism / Travel
 "Reisemagazin"													=> $xa1,
 "Reisen"														=> $xa1 ,
 "Special Interest/Travel"										=> $xa1 ,
 "Themen/Reise"													=> $xa1 ,
 "Reisedoku"													=> $xa1 ,

# 0xA2 Handicraft
 "Unterhaltung/Kunst und Handwerk"								=> $xa2 ,
 "Heimwerken"													=> $xa2 ,
 "Heimwerker"													=> $xa2 ,

# 0xA3 Motoring
 "Rund Ums Auto"												=> $xa3 ,
 "Motor"														=> $xa3 ,
 "Auto"															=> $xa3 ,

# 0xA4 Fitness and health
 "Gesundheit"													=> $xa4 ,
 "Themen/Gesundheit"											=> $xa4 ,

# 0xA5 Cooking
 "Kochen"														=> $xa5 ,
 "Kochshow"														=> $xa5 ,
 "Unterhaltung/Kochen"											=> $xa5 ,

# 0xA6 Advertisement / Shopping
 "Home Shopping"												=> $xa6 ,
 "Homeshopping"													=> $xa6 ,
 "Shopping"														=> $xa6 ,
 "Werbesendung"													=> $xa6 ,

# 0xA7 Gardening
 "Mode"															=> $xa7 ,

# 0xB0 Original language


# 0xB1 Black and white


# 0xB2 Unpublished


# 0xB3 Live broadcast
 "Liveübertragung"												=> $xb3 ,

) ; 

my $PRE  = '<category lang=\"de\">' ;
my $POST = '</category>'  ;

sub myfilter {
  my ($a) = @_;
  if ( exists $REPLACE{$a} ) {     
      return $REPLACE{$a} ;
  } else {
      print STDERR "Warning: Unmanaged category: '$a'\n" ;
      return $a ;
  }
}

while (<>) {
    my $line = $_ ;
    $line =~ s/($PRE)(.*)($POST)/"$1".myfilter("$2")."$3"/ge ;
    print $line;
}  
